unit Unit5;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Edit,
  FMX.ListBox, FMX.Grid, FMX.Layouts,
  UnitV ;

type
  TForm5 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    StringColumn1: TStringColumn;
    StringColumn2: TStringColumn;
    StringColumn3: TStringColumn;
    StringColumn4: TStringColumn;
    StringColumn5: TStringColumn;
    StringColumn6: TStringColumn;
    StringColumn7: TStringColumn;
    StringColumn8: TStringColumn;
    StringColumn9: TStringColumn;
    StringColumn10: TStringColumn;
    StringColumn11: TStringColumn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Edit1: TEdit;
    ComboBox2: TComboBox;
    ListBoxItem1: TListBoxItem;
    ListBoxItem2: TListBoxItem;
    ListBoxItem3: TListBoxItem;
    ListBoxItem4: TListBoxItem;
    ListBoxItem5: TListBoxItem;
    ListBoxItem6: TListBoxItem;
    ListBoxItem7: TListBoxItem;
    ListBoxItem8: TListBoxItem;
    ListBoxItem9: TListBoxItem;
    ListBoxItem10: TListBoxItem;
    ListBoxItem11: TListBoxItem;
    ListBoxItem12: TListBoxItem;
    ListBoxItem13: TListBoxItem;
    ListBoxItem14: TListBoxItem;
    ListBoxItem15: TListBoxItem;
    ListBoxItem16: TListBoxItem;
    ListBoxItem17: TListBoxItem;
    ListBoxItem18: TListBoxItem;
    ListBoxItem19: TListBoxItem;
    ListBoxItem20: TListBoxItem;
    ListBoxItem21: TListBoxItem;
    ListBoxItem22: TListBoxItem;
    ListBoxItem23: TListBoxItem;
    ListBoxItem24: TListBoxItem;
    ListBoxItem25: TListBoxItem;
    ListBoxItem26: TListBoxItem;
    ListBoxItem27: TListBoxItem;
    ListBoxItem28: TListBoxItem;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ListBoxItem1Click(Sender: TObject);
  private
    { private 錾 }
    n,n1,n2 : integer ;
    wh1,od1 : string ;
    procedure SCellClear ;
    procedure SCellDisplay ;
  public
    { public 錾 }
  end;

var
  Form5: TForm5;

implementation

uses
   Unit1 ;

{$R *.fmx}

// N
procedure TForm5.FormShow(Sender: TObject);
begin
   n  := 100 ;    // 1y[W̃f[^
   n1 := 1 ;      // 擪R[hԍ
   n2 := 0 ;      // ł̃R[hԍ
   wh1:= '';      // WHERE߁ii荞ݗpj
   od1:= 'N';     // ORDER BYiяpj
   ComboBox1.ItemIndex := 0 ;
   ComboBox1Change(Sender);
   ComboBox2.ItemIndex := 0 ;
   with StringGrid1 do begin
      Columns[ 0].Header := 'o^ԍ';
      Columns[ 1].Header := 'O';
      Columns[ 2].Header := 'O()';
      Columns[ 3].Header := 'X֔ԍ1';
      Columns[ 4].Header := 'X֔ԍ2';
      Columns[ 5].Header := 'Z1';
      Columns[ 6].Header := 'Z2';
      Columns[ 7].Header := 'dbԍ';
      Columns[ 8].Header := 'FAXԍ';
      Columns[ 9].Header := 'gєԍ';
      Columns[10].Header := 'l';
      RowCount := n ;
   end;
   SCellClear ;
   Button1.Enabled := True ;
   Button2.Enabled := True ;
   Button3.Enabled := True ;
   Button4.Enabled := True ;
   if not(Form1.IBDatabase1.Connected) then begin
      Button1.Enabled := False ;
      Button2.Enabled := False ;
      Button3.Enabled := False ;
      Button4.Enabled := False ;
      exit ;
   end;
   // e[umF
   if not(Form1.DataTableCheck(TABLE1)) then begin
      // e[u݂Ȃ̂Ńe[u쐬
      if not(Form1.DataTableMaking1) then begin
         Button1.Enabled := False ;
         Button2.Enabled := False ;
         Button3.Enabled := False ;
         Button4.Enabled := False ;
      end;
   end
   else begin
      Button1Click(Sender);
   end;
   Button1.SetFocus ;
end;

procedure TForm5.ListBoxItem1Click(Sender: TObject);
begin

end;

// I
procedure TForm5.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// eNA
procedure TForm5.SCellClear ;
var
   i,j : integer ;
begin
   with StringGrid1 do begin
      for j:=0 to RowCount-1 do
         for i:=0 to ColumnCount-1 do
            Cells[i,j] := '';
   end;
end;

// f[^ǂݍ
procedure TForm5.SCellDisplay ;
var
   i,j : integer ;
begin
   with Form1 do begin
      IBQuery1.Active := False ;
      IBTransaction1.Active := False ;
      IBQuery1.ParamCheck := True ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE1);
         if (wh1 <> '') then begin
            Add('  WHERE ' + wh1);
         end;
         Add('  ORDER BY ' + od1 + ';');
      end;
      j := 0 ;
      //
      try
         IBQuery1.Open ;
         IBQuery1.First ;
         if (n1 > 1) then IBQuery1.MoveBy(n1-1);
         while not(IBQuery1.Eof) do begin
            for i:=0 to 10 do begin
               Form5.StringGrid1.Cells[i,j] := IBQuery1.Fields[i].AsString ;
            end;
            Inc(j);
            if (j >= n) then break ;
            IBQuery1.Next ;
         end;
      except
         ;
      end;
      IBQuery1.Active := False ;
      n2 := n1 + j ;
   end;
end;

// ŏ
procedure TForm5.Button1Click(Sender: TObject);
begin
   SCellClear ;
   n1 := 1 ;
   SCellDisplay ;
end;

// O
procedure TForm5.Button2Click(Sender: TObject);
begin
   SCellClear ;
   if (n1 > 1) then begin
      n1 := n1 - n ;
      if (n1 < 1) then n1 := 1 ;
   end;
   SCellDisplay ;
end;

// 
procedure TForm5.Button3Click(Sender: TObject);
begin
   SCellClear ;
   n1 := n2 ;
   SCellDisplay ;
end;

// XV
procedure TForm5.Button4Click(Sender: TObject);
begin
   SCellClear ;
   SCellDisplay ;
end;

// яύX
procedure TForm5.ComboBox1Change(Sender: TObject);
var
   i : integer ;
begin
   i := ComboBox1.ItemIndex ;
   if (i = -1) then exit ;
   Case(i)of
    0:begin // o^ԍ
         od1 := 'N' ;
      end;
    1:begin // o^ԍ
         od1 := 'N DESC' ;
      end;
    2:begin // O
         od1 := 'PNAME' ;
      end;
    3:begin // O
         od1 := 'PNAME DESC' ;
      end;
    4:begin // Oiȁj
         od1 := 'PKANA' ;
      end;
    5:begin // Oiȁj
         od1 := 'PKANA DESC' ;
      end;
    6:begin // X֔ԍ
         od1 := 'ZIP1,ZIP2' ;
      end;
    7:begin // X֔ԍ
         od1 := 'ZIP1 DESC,ZIP2 DESC' ;
      end;
    8:begin // Z
         od1 := 'ADR1,ADR2' ;
      end;
    9:begin // Z
         od1 := 'ADR1 DESC,ADR2 DESC' ;
      end;
   10:begin // dbԍ
         od1 := 'TEL' ;
      end;
   11:begin // dbԍ
         od1 := 'TEL DESC' ;
      end;
   12:begin // FAXԍ
         od1 := 'FAX,N' ;
      end;
   13:begin // FAXԍ
         od1 := 'FAX DESC,N DESC' ;
      end;
   14:begin // gєԍ
         od1 := 'PHONE,N' ;
      end;
   15:begin // gєԍ
         od1 := 'PHONE DESC,N DESC' ;
      end;
   16:begin // l
         od1 := 'BIKO,N' ;
      end;
   17:begin // l
         od1 := 'BIKO DESC,N DESC' ;
      end;
   end;
   Button1Click(Sender);   // ŏ
end;

// i荞
procedure TForm5.ComboBox2Change(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := ComboBox2.ItemIndex ;
   if (i = -1) then exit ;
   s := Edit1.Text ;
   if (s = '') then i := 0 ;
   Case(i)of
    0:begin // ij
         wh1 := '';
      end;
    1:begin // O
         wh1 := 'PNAME' ;
      end;
    2:begin // Oiȁj
         wh1 := 'PKANA' ;
      end;
    3:begin // X֔ԍ1
         wh1 := 'ZIP1' ;
      end;
    4:begin // Z1
         wh1 := 'ADR1' ;
      end;
    5:begin // Z2
         wh1 := 'ADR2' ;
      end;
    6:begin // dbԍ
         wh1 := 'TEL' ;
      end;
    7:begin // FAXԍ
         wh1 := 'FAX' ;
      end;
    8:begin // gєԍ
         wh1 := 'PHONE' ;
      end;
    9:begin // l
         wh1 := 'BIKO' ;
      end;
   end;
   if (wh1 <> '') then begin
      wh1 := wh1 + ' LIKE ''%' + s + '%''' ;
   end;
   Button1Click(Sender);   // ŏ
end;

end.
